diff --git a/openbsc/src/abis_rsl.c b/openbsc/src/abis_rsl.c
index c2ef9e5..bf47947 100644
--- a/openbsc/src/abis_rsl.c
+++ b/openbsc/src/abis_rsl.c
@@ -994,6 +994,10 @@ static int rsl_rx_chan_rqd(struct msgb *msg)
 	lctype = get_ctype_by_chreq(bts, rqd_ref->ra);
 	chreq_reason = get_reason_by_chreq(bts, rqd_ref->ra);
 
+	/* This hack is required until we can modify channel type. */
+	if (chreq_reason != GSM_CHREQ_REASON_LOCATION_UPD)
+		lctype = GSM_LCHAN_TCH_F;
+
 	/* check availability / allocate channel */
 	lchan = lchan_alloc(bts, lctype);
 	if (!lchan) {
diff --git a/openbsc/src/gsm_04_08.c b/openbsc/src/gsm_04_08.c
index dc70c86..0eee009 100644
--- a/openbsc/src/gsm_04_08.c
+++ b/openbsc/src/gsm_04_08.c
@@ -3454,7 +3462,8 @@ int mncc_send(struct gsm_network *net, int msg_type, void *arg)
 					ts = &trx->ts[k];
 					for (l = 0; l < TS_MAX_LCHAN; l++) {
 						lchant = &ts->lchan[l];
-						if (lchant->subscr == subscr) {
+						if (lchant->subscr == subscr
+								&&lchant->type == GSM_LCHAN_TCH_F) {
 							lchan = lchant;
 							break;
 						}
